// READ ONLY
var days = ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"]
var months = ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"]

// Name, Tux ID, Office Hours, Visible on website; try to keep to one line for submitrc script, which parses this to come up with course admins in addition to wmm24
var TA = ["Section TA", "wmm24", "TBA", 0, "William Mongan", "wmm24", "T 5-6:30pm in UC100D", 0, "Ima GoodTA", "tuxID", "T 4-6pm in UC152", 1, "Ima GoodTA2", "tuxID", "M 4-6pm and W 10am-12pm in UC152", 1]

// Section, Name, Email, Office Hours
var instructor = ["Section 001/002/003", "William Mongan", "wmm24@cs.drexel.edu", "T 5-6:30pm in UC100D" ]

// section, website
var website = ["Section 001/002/003", "http://www.cs.drexel.edu/~wmm24/cs283_su16" ]

// Section, Time, Room
var meetingtime = ["Section 001", "TR 2-3:20pm", "SC326", "Section 002", "M 6-8:50pm", "UC151", "Section 003", "T 6:30-9:20pm", "UC151" ]

var credithours = "3 Lecture, 0 Lab, 3 Total"

// Authors, Title, Publisher, ISBN
var books = [ "Randel Bryant and David O'Hallaron", "<a href=\"http://csapp.cs.cmu.edu/public/students.html\">Computer Systems: A Programmer's Perspective</a>, 3rd Edition", "Prentice Hall", "9780134092669"]

var recbooks = [ "W. Richard Stevens and Stephen A. Rago", "Advanced Programming in the UNIX Environment, 3rd Edition", "Addison Wesley", "978-0321637734", "Michael Kerrisk", "<a href=\"http://man7.org/tlpi/\">The Linux Programming Interface</a>", "No Starch Press", "978-1-59237-220-3" ]

var course_description = "This course introduces computer systems, including interaction of hardware and software through the operating system, from the programmer's perspective. Three fundamental abstractions are emphasized; processes, virtual memory, and files. These abstractions provide programmers a common interface to a wide variety of hardware devices. Topics covered include linking, system level I/O, concurrent programming, and network programming."

var prereqs = "CS265"

var coursenum = "CS283"
var coursename = "Systems Programming"

var shortterm = "summer2016"

var leftbar = [ "Main Page", "index.html", "Lectures", "lectures.html", "Labs", "labs.html", "Assignments and Study Guides", "assignments.html", "Course Guidelines", "course_guidelines.html", "Resources", "resources.html", "Syllabus", "syllabus.html", "Grading Policy", "grading_policy.html", "<b>Piazza Discussion Forum</b>", "http://piazza.com/drexel/" + shortterm + "/"+ coursenum.toLowerCase() + "/home", "Piazza Course Signup", "http://piazza.com/drexel/" + shortterm + "/"+ coursenum.toLowerCase(), "BBLearn", "http://learn.dcollege.net", "Getting and Using a Tux Account<br>(contact me with your Drexel user ID and student ID if you cannot create an account)", "https://www.cs.drexel.edu/~kschmidt/Ref/csLogin.html" ]

var grades = [ "Homework and Programming Assignments", "40%", "Labs", "20%", "Midterm Exam", "15%", "Final Exam", "25%"]

var grade_breakdown = ["A range (A+, A, A-)", "[90, 100)", "B range", "[80, 90)", "C range", "[70, 80)", "D range", "[60, 70)", "F range", "[0, 60)"]

var objectives = [ "To obtain practical skills in concurrency and multithreaded programming.", "To become familiar with and comfortable using the programming facilities of the operating system, including a) File system structures, b) Network / socket programming, c) Memory system and shared memory, d) Thread mechanisms, and e) I/O system structures.", "To operate in and self-manage in programming teams." ]

var audience = "This is a core computer science course required by all Computer Science majors. It should be taken in the 3rd year. This course is appropriate for students interested in modern computer architecture, computer systems and high performance computing."

var shouldKnow = [ "Programming constructs and data structures in C and/or C++.", "Effectively use of the Unix programming environment - shell, file system, scripts, pipes, regular expressions, filters, program development tools", "Use of effective procedures and tools for building, debugging, testing, tuning, and maintaining programs" ]

var willKnow = [ "Use, develop and become familiar with programming constructs that interface with the operating system to provide functionality to the programmer and the user", "Write portable systems-level applications", "Coordinate threads using shared memory and distributed message-passing on a variety of platforms" ]

var topics = [ "Concurrency (Chapter 13, 2nd Edition Chapter 13)", "Process and Thread Management", "Process Tables (Chapter 8)", "Compilers, Linkers and Loaders (Chapter 7)", "Memory Systems (Chapters 6, 9, 2nd Edition Chapters 6, 10)", "File Systems (Chapter 10, 2nd Edition Chapter 11)", "Network Programming (Chapter 11, 2nd Edition Chapter 12)" ]

var submission_method = "All assignments must be submitted using your Bitbucket account.  Create a Bitbucket account using your university e-mail address (this gives you an upgraded academic account including private repositories by default, which is required), and create a repository named <font color=red>abc123-" + coursenum + "-" + shortterm + " where abc123 is your Drexel username</font>.  Add your instructors as collaborators (Bill Mongan's Bitbucket account is BillJr99).  In the first week, you will submit an text file containing only one line: the git link to your repository.  Future assignments will be pushed to this repository for access, grading, and feedback by the instructor and/or teaching assistants.  Each assignment should be a directory or branch under your repository named the submission code on the assignment page (this is found in the first column; for example, A1)."

var latePolicy = "<b>Officially, no late assignments will be accepted. Students are expected to do their assignments by themselves.</b> Assignments that are late are not accepted as a rule, but may be accepted for up to 50% credit under the appropriate circumstances.  No credit can be given for late assignments under any circumstances once the assignment was discussed in class (typically the class day following the due date).  Requesting an exemption to this policy at any time will result in a one-half letter grade reduction from the final grade per incident."

var csHonestyPolicy = "The CCI Academic Honesty policy is in effect for this course.  Please see the policy at <a href=\"http://drexel.edu/cci/resources/current-students/undergraduate/policies/cs-academic-integrity/\">http://drexel.edu/cci/resources/current-students/undergraduate/policies/cs-academic-integrity/</a>." //"The CS Academic Honesty policy is in effect for this course.  Please see the policy at <a href=\"http://drexel.edu/cs/academics/undergrad/policies/academic-integrity/\">http://drexel.edu/cs/academics/undergrad/policies/academic-integrity/</a>."

// Submission Code on Submit, Assignment Name, Hyperlink, Due Date, Grader Number (used above in TA array as index to name)
// Keep this on one line for parsing in the toSubmitRC program
// Can do var projects as well
var assignments = [ "G1", "Anagram Solver", "assignments/anagrams.html", "7/12/2016", 0, "G2", "Mosiac Generator with OpenCV", "assignments/mosaic/mosaic.html", "8/2/2016", 0, "G3", "Network Programming", "assignments/network.html", "8/16/2016", 0, "EC", "Shell", "assignments/shlab/index.html", "8/31/2016", 0, "W1", "Linkers and Memory Review Assignment", "assignments/linker_memory.html", "Nothing to Hand In", 0, "EVAL", "Submit Your Course Evaluation Documentation Here", "", "8/31/2016", 1 ]

var labs = [ "L0", "Setting up your Bitbucket repository", "", "6/28/2016", 0, "L1", "Pointers and Dynamic Memory", "labs/pointers_dynamicarray.html", "7/5/2016", 0, "L2", "File Manipulation", "labs/folder-sync.html", "7/24/2016", 0, "L3", "HTTP Client and Server Socket Lab", "labs/httpclient.html", "8/8/2016", 0, "L4", "Intro to Concurrent Programming", "labs/concurrentintro.html", "8/24/2016", 1, "L5", "MapReduce Lab", "labs/mapreduce.html", "8/31/2016", 0 ]

var projects = [ ]

// order these by sections in meetingtime variable above
var final_date = [ "TBA" ]
var final_time = [ "TBA" ]
var final_room = [ "TBA" ]

function finalString() {
        str = "";

        for(i = 0; i < final_date.length; i++) {
                str = str + "<b>" + meetingtime[3 * i] + "</b>: " + final_date[i] + " at " + final_time[i] + " in " + final_room[i]
                if(i < final_date.length - 1) {
                        str = str + "<br>"
                }
        }

        return str;
}

crn = "XLSCS283001002003atm"
separator = "_" // _ for cross lists, . for regular crn
quartercode = "201545"
bblearn_content_base = "https://learn.dcollege.net/bbcswebdav/courses/" + crn + separator + quartercode + "/" + coursenum.toLowerCase(); //copy content collection folder to course content collection, then edit the folder or an item inside for the web folder link, handling cross-listed shells

// Week Number, Title, Hyperlink, Readings, Notes
var lectures = [
  1, "Intro to C Programming with gcc, gdb, and Valgrind", bblearn_content_base + "/lectures/1_gcc.pptx", "<a href=\"../cs283/resources/code/ieees.c\">ieees.c</a><br><a href=\"../cs283/resources/code/ieeep.h\">ieeep.h</a><br><a href=\"" + bblearn_content_base + "/resources/svn.htm\">Creating a repository</a><br><a href=\"http://www.vogella.com/tutorials/Git/article.html\">Git Tutorial by Lars Vogel</a><br><a href=\"https://confluence.atlassian.com/display/BITBUCKET/Getting+started+with+Bitbucket\">Getting Started with Bitbucket</a><br><a href=\"https://learn.dcollege.net/bbcswebdav/users/wmm24/common/git_bitbucket\">My video tutorial on bitbucket</a>", "",
  2, "Intro to C Programming with gcc, gdb, and Valgrind", bblearn_content_base + "/lectures/1_gcc.pptx", "", "",
  3, "File I/O", bblearn_content_base + "/lectures/2_fileio.pptx", "CSAPP Chapter 11 (2nd Edition Chapter 10)", "",
  4, "File I/O", bblearn_content_base + "/lectures/2_fileio.pptx", "CSAPP Chapter 11 (2nd Edition Chapter 10)", "",
  5, "Network Programming", bblearn_content_base + "/lectures/3_networkprog.pptx", "CSAPP Chapter 12 (2nd Edition Chapter 11)", "",
  6, "Concurrency", bblearn_content_base + "/lectures/4_concurrency.pptx", "CSAPP Chapter 13 (2nd Edition Chapter 12)<br><a href=\"https://computing.llnl.gov/tutorials/pthreads/\">pthreads Tutorial</a><br>Barriers", "",
  7, "Parallelism", bblearn_content_base + "/lectures/5_parallelism.pptx", "", "Last Week to Withdraw",
  7, "Midterm Exam", "", "", "Midterm",
  8, "Process Management, Interprocess Communication, and Signals", bblearn_content_base + "/lectures/6_procmgt.pptx", "CSAPP Chapter 8<br><a href=\"" + bblearn_content_base + "/resources/ipc.pdf\">IPC Reference</a><br><a href=\"" + bblearn_content_base + "/resources/ipctut.pdf\">IPC Tutorial</a><br><a href=\"../cs283/resources/code/race.c\">race.c</a><br><a href=\"../cs283/resources/code/sigusr.c\">sigusr.c</a><br><a href=\"../cs283/resources/code/tellwait_pipe.c\">tellwait_pipe.c</a><br><a href=\"../cs283/resources/code/tellwait_sig.c\">tellwait_sig.c</a><br><a href=\"../cs283/resources/code/tshm.c\">tshm.c</a><br><a href=\"../cs283/resources/code/unrace.c\">unrace.c</a>", "",
  9, "Writing a Shell", bblearn_content_base + "/lectures/7_shell.pptx", "", "",
  9, "Memory and Cache", bblearn_content_base + "/lectures/8_virtualmem.pptx", "CSAPP Chapters 6, 10 (2nd Edition Chapters 6, 9)", "",
  10, "Compiling, Linking and Loading", bblearn_content_base + "/lectures/9_linking.pptx", "CSAPP Chapter 7", "",
  11, "Final Exam: " + finalString(), "", "", "Final Exam"
]

// boolean flag for mon, tue, we, thu, fri; for each section number
var class_days = [ 0,1,0,1,0, 1,0,0,0,0 ]

var holidays = [ "7/4/2016" ]

var term_start = "6/20/2016"
var class_end = "8/29/2016"
var term_end = "9/3/2016"

//M. Galloway made following changes on 7/27/16.
//Variables below used in syllabus.html by PrintTerm() function in coursePrinter.js.
//courses.js used to set these variables' values.
var termcode = quartercode //set above
//Academic term
var term = "Summer 2015-16"
