function listInstructors() {
  var i
  document.write("<ol>")

  for(i = 0; i < instructor.length; i += 4) {
    document.write("<li><b>" + instructor[i] + "</b>: " + instructor[i+1] + " (" + instructor[i+2] + ")<br>Office Hours: " + instructor[i+3] + "</li>")
  }

document.write("</ol>")
}

function printCreditHours() {
  document.write(credithours);
}

function printTerm() {
  document.write(termcode + ": " + term);
}

function listTas() {
  var i
  var anyTAs = 0
  document.write("<ol>")

  for(i = 0; i < TA.length; i += 4) {
    if(TA[i+3] == 1) { // if this is a real visible TA, display it.  Some TA's may not be posted because they're course admins for submit purposes
      anyTAs = 1
      document.write("<li><b>" + TA[i] + "</b> (" + TA[i+1] + ")<br>Office Hours: " + TA[i+2] + "</li>")
    }
  }

  if(anyTAs == 0) {
    document.write("<li>None</li>")
  }

  document.write("</ol>")
}

function listMeetingTimes() {
  var i

  for(i = 0; i < meetingtime.length; i += 3) {
    document.write("<b>" + meetingtime[i] + "</b>: " + meetingtime[i+1] + " in Room " + meetingtime[i+2] + "<br>")
  }
}

function listCourseWebPage() {
  var i

  for(i = 0; i < website.length; i += 2) {
    document.write(website[i] + ": <a href='" + website[i+1] + "'>" + website[i+1] + "</a><br>")
  }
}

function printLatePolicy() {
  document.write(latePolicy)
}

function printCSHonestyPolicy() {
  document.write(csHonestyPolicy)
}

function listBooks() {
  var i = 0

  document.write("<ol>")

  for(i = 0; i < books.length; i += 4) {
    document.write("<li><b>" + books[i] + "</b>.  " + books[i+1] + ".  " + books[i+2] + ": " + books[i+3] + "</li>")
  }

  if(recbooks.length > 0) {
    for(i = 0; i < recbooks.length; i += 4) {
      document.write("<li>Recommended: <b>" + recbooks[i] + "</b>.  " + recbooks[i+1] + ".  " + recbooks[i+2] + ": " + recbooks[i+3] + "</li>")
    }
  }

  document.write("</ol>")
}

// Assumes the primary website for printing the left bar
function left_nav(separator, linktags, latest) {
  if(separator == undefined) {
      separator = "<br>";
  }

  if(linktags == undefined) {
      linktags = "";
  }

  if(latest == undefined) {
  latest = 1;
  }

  var i = 0

  for(i = 0; i < leftbar.length; i+= 2) {
    // append website root to non-external links
    if(leftbar[i+1].indexOf("http") == -1) {
      document.write("<a " + linktags + " href='" + website[1] + "/" + leftbar[i+1] + "'>" + leftbar[i] + "</a>" + separator)
    } else {
      document.write("<a " + linktags + " href='" + leftbar[i+1] + "'>" + leftbar[i] + "</a>" + separator)
    }
    if(leftbar[i] == "Announcements" && latest != 0) {
      document.write("<b>Latest: " + latestannouncement + "</b>" + separator)
    }
    document.write(separator)
  }
}

function description() {
  document.write(course_description + "<br>")
}

function listPrereqs() {
  document.write(prereqs + "<br>")
}

function printTitle() {
  document.write(coursenum + " " + coursename)
}

function setTitle() {
  document.title = coursenum + " " + coursename
}

function listAnnouncements() {
  var i = 0

  if(announcements.length > 0) {
    document.write("<ol>")
  }

  for(i = 0; i < announcements.length; i += 2) {
    var curAnnDate = new Date(announcements[i])

    document.write("<li><b>" + days[curAnnDate.getDay()] + ", " + months[curAnnDate.getMonth()] + " " + curAnnDate.getDate() + ", " + curAnnDate.getFullYear() + "</b>: " + announcements[i+1] + "</li>")
  }

  if(announcements.length > 0) {
    document.write("</ol>")
  }
}

function listGrades() {
  var i = 0

  document.write("<ol>")

  for(i = 0; i < grades.length; i += 2) {
    document.write("<li>" + grades[i] + " " + grades[i+1] + "</li>")
  }

  document.write("</ol>")
}

function listGradeBreakdown() {
  var i = 0

  document.write("<ul>")

  for(i = 0; i < grade_breakdown.length; i += 2) {
    document.write("<li>" + grade_breakdown[i] + " is a course average " + grade_breakdown[i+1] + "</li>")
  }

  document.write("</ul>")
}

function listObjectives() {
  var i = 0

  document.write("<ol>")

  for(i = 0; i < objectives.length; i++) {
    document.write("<li>" + objectives[i] + "</li>")
  }

  document.write("</ol>")
}

function printAudience() {
  document.write(audience)
}

function printShouldKnow() {
  var i = 0

  document.write("<ol>")

  for(i = 0; i < shouldKnow.length; i++) {
    document.write("<li>" + shouldKnow[i] + "</li>")
  }

  document.write("</ol>")
}

function printWillKnow() {
  var i = 0

  document.write("<ol>")

  for(i = 0; i < willKnow.length; i++) {
       document.write("<li>" + willKnow[i] + "</li>")
  }

  document.write("</ol>")
}


function listTopics() {
  var i = 0

  document.write("<ol>")

  for(i = 0; i < topics.length; i++) {
       document.write("<li>" + topics[i] + "</li>")
  }

  document.write("</ol>")
}

function printSubmissionMethod() {
  document.write(submission_method + "<br>")
}

function listAssignments() {
  var i = 0

  document.write("<table border=\"2\" cellspacing=\"3\" style=\"border-collapse: collapse\" bordercolor=\"#111111\" width=\"100%\"><tbody><tr>")
  document.write("<td width=\"10%\"><b>Submission Code</b></td>")
  document.write("<td width=\"30%\"><b>Assignment</b></td>")
  document.write("<td width=\"30%\"><b>Due Date</b></td>")
  document.write("<td width=\"30%\"><b>Grader</b></td>")
  document.write("</tr>")

  for(i = 0; i < assignments.length; i += 5) {
    document.write("<tr>")

    document.write("<td>" + assignments[i] + "</td>")
    if(assignments[i+2].length > 1) {
        document.write("<td><a href='" + assignments[i+2] + "'>" + assignments[i+1] + "</a></td>")
    } else {
        document.write("<td>" + assignments[i+1] + "</td>")
    }
    if(!assignments[i+3].toLowerCase().match("nothing to hand in")) {
      var dueDate = new Date(assignments[i+3])
      document.write("<td>" + days[dueDate.getDay()] + ", " + months[dueDate.getMonth()] + " " + dueDate.getDate() + ", " + dueDate.getFullYear() + "</td>")
    } else {
      document.write("<td>Nothing to Hand In</td>")
    }
    document.write("<td>" + TA[assignments[i+4] * 4] + "</td>")

    document.write("</tr>")
  }

  document.write("</tr></tbody></table>")
}


function listLabs() {
  var i = 0

  document.write("<table border=\"2\" cellspacing=\"3\" style=\"border-collapse: collapse\" bordercolor=\"#111111\" width=\"100%\"><tbody><tr>")
  document.write("<td width=\"10%\"><b>Submission Code</b></td>")
  document.write("<td width=\"30%\"><b>Lab</b></td>")
  document.write("<td width=\"30%\"><b>Due Date</b></td>")
  document.write("<td width=\"30%\"><b>Grader</b></td>")
  document.write("</tr>")

  for(i = 0; i < labs.length; i += 5) {
    document.write("<tr>")

    document.write("<td>" + labs[i] + "</td>")
    if(labs[i+2].length > 1) {
        document.write("<td><a href='" + labs[i+2] + "'>" + labs[i+1] + "</a></td>")
    } else {
        document.write("<td>" + labs[i+1] + "</td>")
    }
    if(!labs[i+3].toLowerCase().match("nothing to hand in")) {
      var dueDate = new Date(labs[i+3])
      document.write("<td>" + days[dueDate.getDay()] + ", " + months[dueDate.getMonth()] + " " + dueDate.getDate() + ", " + dueDate.getFullYear() + "</td>")
    } else {
      document.write("<td>Nothing to Hand In</td>")
    }
    document.write("<td>" + TA[labs[i+4] * 4] + "</td>")

    document.write("</tr>")
  }

  document.write("</tr></tbody></table>")
}

function listProjects() {
  var i = 0

  document.write("<table border=\"2\" cellspacing=\"3\" style=\"border-collapse: collapse\" bordercolor=\"#111111\" width=\"100%\"><tbody><tr>")
  document.write("<td width=\"10%\"><b>Submission Code</b></td>")
  document.write("<td width=\"30%\"><b>Project</b></td>")
  document.write("<td width=\"30%\"><b>Due Date</b></td>")
  document.write("<td width=\"30%\"><b>Grader</b></td>")
  document.write("</tr>")

  for(i = 0; i < projects.length; i += 5) {
    document.write("<tr>")

    document.write("<td>" + projects[i] + "</td>")
    if(projects[i+2].length > 1) {
        document.write("<td><a href='" + projects[i+2] + "'>" + projects[i+1] + "</a></td>")
    } else {
        document.write("<td>" + projects[i+1] + "</td>")
    }
    if(!projects[i+3].toLowerCase().match("nothing to hand in")) {
      var dueDate = new Date(projects[i+3])
      document.write("<td>" + days[dueDate.getDay()] + ", " + months[dueDate.getMonth()] + " " + dueDate.getDate() + ", " + dueDate.getFullYear() + "</td>")
    } else {
      document.write("<td>Nothing to Hand In</td>")
    }
    document.write("<td>" + TA[projects[i+4] * 4] + "</td>")

    document.write("</tr>")
  }

  document.write("</tr></tbody></table>")
}

function listWhatsDueThisWeek() {
  var i = 0

  document.write("<table border=\"2\" cellspacing=\"3\" style=\"border-collapse: collapse\" bordercolor=\"#111111\" width=\"100%\"><tbody><tr>")
  document.write("<td width=\"10%\"><b>Submission Code</b></td>")
  document.write("<td width=\"30%\"><b>Deliverable</b></td>")
  document.write("<td width=\"30%\"><b>Due Date</b></td>")
  document.write("<td width=\"30%\"><b>Grader</b></td>")
  document.write("</tr>")

  for(i = 0; i < projects.length; i += 5) {
    if(dueThisWeek(projects[i+3])) {
      document.write("<tr>")

      document.write("<td>" + projects[i] + "</td>")
      if(projects[i+2].length > 1) {
        document.write("<td><a href='" + projects[i+2] + "'>" + projects[i+1] + "</a></td>")
      } else {
        document.write("<td>" + projects[i+1] + "</td>")
      }
      if(!projects[i+3].toLowerCase().match("nothing to hand in")) {
        var dueDate = new Date(projects[i+3])
        document.write("<td>" + days[dueDate.getDay()] + ", " + months[dueDate.getMonth()] + " " + dueDate.getDate() + ", " + dueDate.getFullYear() + "</td>")
      } else {
        document.write("<td>Nothing to Hand In</td>")
      }
      document.write("<td>" + TA[projects[i+4] * 4] + "</td>")

      document.write("</tr>")
    }
  }

  for(i = 0; i < assignments.length; i += 5) {
    if(dueThisWeek(assignments[i+3])) {
      document.write("<tr>")

      document.write("<td>" + assignments[i] + "</td>")
        if(assignments[i+2].length > 1) {
          document.write("<td><a href='" + assignments[i+2] + "'>" + assignments[i+1] + "</a></td>")
        } else {
          document.write("<td>" + assignments[i+1] + "</td>")
        }
        if(!assignments[i+3].toLowerCase().match("nothing to hand in")) {
          var dueDate = new Date(assignments[i+3])
          document.write("<td>" + days[dueDate.getDay()] + ", " + months[dueDate.getMonth()] + " " + dueDate.getDate() + ", " + dueDate.getFullYear() + "</td>")
          } else {
            document.write("<td>Nothing to Hand In</td>")
            }
          document.write("<td>" + TA[assignments[i+4] * 4] + "</td>")

          document.write("</tr>")
    }
  }

  for(i = 0; i < labs.length; i += 5) {
    if(dueThisWeek(labs[i+3])) {
      document.write("<tr>")

      document.write("<td>" + labs[i] + "</td>")
      if(labs[i+2].length > 1) {
        document.write("<td><a href='" + labs[i+2] + "'>" + labs[i+1] + "</a></td>")
      } else {
        document.write("<td>" + labs[i+1] + "</td>")
      }
      if(!labs[i+3].toLowerCase().match("nothing to hand in")) {
        var dueDate = new Date(labs[i+3])
        document.write("<td>" + days[dueDate.getDay()] + ", " + months[dueDate.getMonth()] + " " + dueDate.getDate() + ", " + dueDate.getFullYear() + "</td>")
        } else {
          document.write("<td>Nothing to Hand In</td>")
        }
        document.write("<td>" + TA[labs[i+4] * 4] + "</td>")

        document.write("</tr>")
    }
  }

document.write("</tr></tbody></table>")
}


function dueThisWeek(dueDate) {
  if(dueDate.toLowerCase().match("nothing to hand in")) {
    return false
  } else {
    var d = new Date(dueDate)
    var today = new Date()
    var one_day=1000*60*60*24
    var dateDiff = d - today
    if(dateDiff < -1 * (1000*60*60*24)) {
      return false
    } else {
      var daysDiff = dateDiff / one_day
      if(daysDiff < 7) {
        return true
      } else {
        return false
      }
    }
  }
}

function listDrexelPolicies() {
  document.write("In addition to the course policies listed on this syllabus, course assignments or course website, the following University policies are in effect:");
  document.write("<ul>")
  document.write("<li>Academic Honesty: <a href=\"http://www.drexel.edu/provost/policies/academic_dishonesty.asp\">http://www.drexel.edu/provost/policies/academic_dishonesty.asp</a></li>")
  document.write("<li>Judicial Affairs Academic Integrity: <a href=\"http://drexel.edu/studentaffairs/community_standards/facultyStaff/integrity/\">http://drexel.edu/studentaffairs/community_standards/facultyStaff/integrity/</a></li>")
  document.write("<li>Official Final Exam Schedule: <a href=\"http://www.drexel.edu/registrar/exams/\">http://www.drexel.edu/registrar/exams/</a></li>")
  document.write("<li>Students with Disability Statement: <a href=\"http://www.drexel.edu/ods/student_reg.html\">http://www.drexel.edu/ods/student_reg.html</a></li>")
  document.write("<li>Course Drop Policy: <a href=\"http://www.drexel.edu/provost/policies/course_drop.asp\">http://www.drexel.edu/provost/policies/course_drop.asp</a></li>")
  document.write("<li>The instructor may, at his/her/their discretion, change any part of the course during the term, including assignments, grade brakdowns, due-dates, and the schedule.  Such changes will be communicated to students via the course web site Announcements page.  This page should be checked regularly and frequently for such changes and announcements.  Other announcements, although rare, may include class cancellations and other urgent announcements.</li>")
  document.write("<li>Drexel Student Learning Priorities: <a href=\"http://www.drexel.edu/provost/learningpriorities/\">http://www.drexel.edu/provost/learningpriorities/</a></li>")
  document.write("</ul>")
}

function listLectures() {
    var startDate = new Date(term_start) // Assume Monday
    var i = 0

    document.write("<table border=\"2\" cellspacing=\"3\" style=\"border-collapse: collapse\" bordercolor=\"#111111\" width=\"100%\"><tbody><tr>")
    document.write("<td width=\"5%\"><b>Week #</b></td>")
    document.write("<td width=\10%\"><b>Dates</b></td>")
    document.write("<td width=\10%\"><b>Lecture Topics</b></td>")
    document.write("<td width=\10%\"><b>Labs, Readings and Whitepapers</b></td>")
    document.write("<td width=\10%\"><b>Notes</b></td>")
    document.write("</tr>")

    var lastWeekNum = 0
    for(i = 0; i < lectures.length; i += 5) {
      var thisWeekNum = lectures[i]
      var thisWeekDate = new Date(startDate)
      thisWeekDate.setDate(thisWeekDate.getDate() + (7 * (thisWeekNum - 1)))

      document.write("<tr>")
      document.write("<td>" + lectures[i] + "</td>")
      document.write("<td>Week of " + formatDateMDY(thisWeekDate) + "</td>")
      if(lectures[i+2].length > 0) {
        document.write("<td><a href='" + lectures[i+2] + "'>" + lectures[i+1] + "</a></td>")
      } else {
        document.write("<td>" + lectures[i+1] + "</td>")              }
      document.write("<td>" + lectures[i+3] + "</td>")
      document.write("<td>" + lectures[i+4] + "</td>")
      document.write("</tr>")

      lastWeekNum = thisWeekNum
    }

    document.write("</tr></tbody></table>")

    if(holidays.length > 0) {
      var j = 0

      document.write("<p><b>Holidays</b></p>")
      document.write("Please note the following holidays.  If we have class normally scheduled on these days, we will not meet.")

      document.write("<ul>")
      for(j = 0; j < holidays.length; j++) {
        document.write("<li>" + holidays[j] + "</li>")
      }
      document.write("</ul>")
    }
}

function formatDateMDY(theDate) {
  var theDateDate = new Date(theDate)
  var y = theDateDate.getYear()
  if(y < 1900) {
    y = y + 1900
  }
  return months[theDateDate.getMonth()] + " " + theDateDate.getDate() + ", " + y
}
